Imports System.Runtime.InteropServices
Imports System.Threading
Imports System.ComponentModel
Imports System.Data
Imports System.Windows.Forms
Imports Microsoft.Win32
Imports System.io

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region "Variables"
    Private bEAN8 As Boolean
    Private bEAN13 As Boolean
    Private bIT25 As Boolean
    Private bUPCE As Boolean
    Private bUPCA As Boolean
    Private bEAN128 As Boolean
    Private bCode128 As Boolean
    Private bCode39 As Boolean
    Private nThreshold As Integer
    Private dQuietZone As Double
    Private dMinBarHeight As Double
    Private dMaxBarHeight As Double
    Private bDiskFile As Boolean

    Private nImgFormat As Integer
    Private nPageOption As Integer
    Private nRLeft As Integer
    Private nRTop As Integer
    Private nRRight As Integer
    Private nRBottom As Integer
    Private nImgWidth As Integer
    Private nImgHeight As Integer
#End Region

#Region "DLL Imports"

    <DllImport("kernel32.dll", SetlastError:=True)> Private Shared Function LoadLibrary(ByVal LibFileName As String) As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True)> Private Shared Function De1DInit() As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True)> Private Shared Function De1DSetKey(ByVal Key As String) As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True)> Private Shared Function De1DCleanUp() As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True)> Private Shared Function De1DGetCount() As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True)> Private Shared Function De1DGetType(ByVal CodeIndex As Integer) As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True)> Private Shared Function De1DGetStrLen(ByVal CodeIndex As Integer) As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True)> Private Shared Function De1DGetCharAt(ByVal CodeIndex As Integer, ByVal CharIndex As Integer) As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True)> Private Shared Function De1DGetRect(ByVal CodeIndex As Integer, ByRef P1 As Long, ByRef P2 As Long, ByRef P3 As Long, ByRef P4 As Long) As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True, CallingConvention:=CallingConvention.StdCall)> Private Shared Function De1DLoadFromMem(ByVal Buffer As Byte(), ByVal Size As Long, ByVal ImgFormat As Integer) As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True)> Private Shared Function De1DLoadFromFile(ByVal FileName As String, ByVal ImgFormat As Integer) As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True)> Private Shared Function De1DGetNumOfPages() As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True)> Private Shared Function De1DSetPage(ByVal PageIndex As Integer) As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True)> Private Shared Function De1DGetImgSize(ByRef Width As Integer, ByRef Height As Integer) As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True)> Private Shared Function De1DSetThreshold(ByVal Threshold As Integer) As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True)> Private Shared Function De1DSetRegion(ByVal Left As Integer, ByVal Top As Integer, ByVal Right As Integer, ByVal Bottom As Integer) As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True)> Private Shared Function De1DSetLimit(ByVal QuietZoneSize As Double, ByVal MinBarHeight As Double, ByVal MaxBarHeight As Double) As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True)> Private Shared Function De1DScanType(ByVal CodeType As Integer, ByVal Enabled As Integer) As Integer
    End Function

    <DllImport("Decode1D.dll", SetlastError:=True)> Private Shared Function De1DScan() As Integer
    End Function
#End Region

#Region "Windows Form Designer generated code"

    Public Sub New()
        MyBase.New()

        Dim WinDir As String
        Dim DLLPath As String

        WinDir = System.Environment.GetEnvironmentVariable("WinDir")
        DLLPath = WinDir & "\System32\Decode1D.dll"
        LoadLibrary(DLLPath)

        De1DInit()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents Label6 As System.Windows.Forms.Label
    Friend WithEvents Label7 As System.Windows.Forms.Label
    Friend WithEvents Label8 As System.Windows.Forms.Label
    Friend WithEvents Label9 As System.Windows.Forms.Label
    Friend WithEvents Label10 As System.Windows.Forms.Label
    Friend WithEvents Label11 As System.Windows.Forms.Label
    Friend WithEvents Label12 As System.Windows.Forms.Label
    Friend WithEvents chkCode39 As System.Windows.Forms.CheckBox
    Friend WithEvents chkCode128 As System.Windows.Forms.CheckBox
    Friend WithEvents chkEAN128 As System.Windows.Forms.CheckBox
    Friend WithEvents chkEAN13 As System.Windows.Forms.CheckBox
    Friend WithEvents chkEAN8 As System.Windows.Forms.CheckBox
    Friend WithEvents chkUPCA As System.Windows.Forms.CheckBox
    Friend WithEvents chkUPCE As System.Windows.Forms.CheckBox
    Friend WithEvents chkIT25 As System.Windows.Forms.CheckBox
    Friend WithEvents txtThreshold As System.Windows.Forms.TextBox
    Friend WithEvents cbxQuietZone As System.Windows.Forms.ComboBox
    Friend WithEvents cbxMinBarHeight As System.Windows.Forms.ComboBox
    Friend WithEvents cbxMaxBarHeight As System.Windows.Forms.ComboBox
    Friend WithEvents GroupBox2 As System.Windows.Forms.GroupBox
    Friend WithEvents Label14 As System.Windows.Forms.Label
    Friend WithEvents Label15 As System.Windows.Forms.Label
    Friend WithEvents Label16 As System.Windows.Forms.Label
    Friend WithEvents Label17 As System.Windows.Forms.Label
    Friend WithEvents Label18 As System.Windows.Forms.Label
    Friend WithEvents Label19 As System.Windows.Forms.Label
    Friend WithEvents Label20 As System.Windows.Forms.Label
    Friend WithEvents Label21 As System.Windows.Forms.Label
    Friend WithEvents txtWidth As System.Windows.Forms.TextBox
    Friend WithEvents txtHeight As System.Windows.Forms.TextBox
    Friend WithEvents txtPages As System.Windows.Forms.TextBox
    Friend WithEvents cbxPages As System.Windows.Forms.ComboBox
    Friend WithEvents txtRLeft As System.Windows.Forms.TextBox
    Friend WithEvents txtRTop As System.Windows.Forms.TextBox
    Friend WithEvents txtRWidth As System.Windows.Forms.TextBox
    Friend WithEvents txtRHeight As System.Windows.Forms.TextBox
    Friend WithEvents txtBarcodeInfo As System.Windows.Forms.TextBox
    Friend WithEvents btnScanningOptions As System.Windows.Forms.Button
    Friend WithEvents btnImageInfo As System.Windows.Forms.Button
    Friend WithEvents btnOpen As System.Windows.Forms.Button
    Friend WithEvents btnScan As System.Windows.Forms.Button
    Friend WithEvents btnClose As System.Windows.Forms.Button
    Friend WithEvents OFD As System.Windows.Forms.OpenFileDialog
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.GroupBox1 = New System.Windows.Forms.GroupBox
        Me.btnScanningOptions = New System.Windows.Forms.Button
        Me.cbxMaxBarHeight = New System.Windows.Forms.ComboBox
        Me.cbxMinBarHeight = New System.Windows.Forms.ComboBox
        Me.cbxQuietZone = New System.Windows.Forms.ComboBox
        Me.chkIT25 = New System.Windows.Forms.CheckBox
        Me.chkUPCE = New System.Windows.Forms.CheckBox
        Me.chkUPCA = New System.Windows.Forms.CheckBox
        Me.chkEAN8 = New System.Windows.Forms.CheckBox
        Me.chkEAN13 = New System.Windows.Forms.CheckBox
        Me.chkEAN128 = New System.Windows.Forms.CheckBox
        Me.chkCode128 = New System.Windows.Forms.CheckBox
        Me.chkCode39 = New System.Windows.Forms.CheckBox
        Me.Label12 = New System.Windows.Forms.Label
        Me.Label11 = New System.Windows.Forms.Label
        Me.Label10 = New System.Windows.Forms.Label
        Me.Label9 = New System.Windows.Forms.Label
        Me.Label8 = New System.Windows.Forms.Label
        Me.Label7 = New System.Windows.Forms.Label
        Me.Label6 = New System.Windows.Forms.Label
        Me.Label5 = New System.Windows.Forms.Label
        Me.Label4 = New System.Windows.Forms.Label
        Me.Label3 = New System.Windows.Forms.Label
        Me.Label2 = New System.Windows.Forms.Label
        Me.Label1 = New System.Windows.Forms.Label
        Me.txtThreshold = New System.Windows.Forms.TextBox
        Me.GroupBox2 = New System.Windows.Forms.GroupBox
        Me.btnImageInfo = New System.Windows.Forms.Button
        Me.txtRHeight = New System.Windows.Forms.TextBox
        Me.txtRWidth = New System.Windows.Forms.TextBox
        Me.txtRTop = New System.Windows.Forms.TextBox
        Me.txtRLeft = New System.Windows.Forms.TextBox
        Me.cbxPages = New System.Windows.Forms.ComboBox
        Me.txtPages = New System.Windows.Forms.TextBox
        Me.txtHeight = New System.Windows.Forms.TextBox
        Me.txtWidth = New System.Windows.Forms.TextBox
        Me.Label21 = New System.Windows.Forms.Label
        Me.Label20 = New System.Windows.Forms.Label
        Me.Label19 = New System.Windows.Forms.Label
        Me.Label18 = New System.Windows.Forms.Label
        Me.Label17 = New System.Windows.Forms.Label
        Me.Label16 = New System.Windows.Forms.Label
        Me.Label15 = New System.Windows.Forms.Label
        Me.Label14 = New System.Windows.Forms.Label
        Me.txtBarcodeInfo = New System.Windows.Forms.TextBox
        Me.btnOpen = New System.Windows.Forms.Button
        Me.btnScan = New System.Windows.Forms.Button
        Me.btnClose = New System.Windows.Forms.Button
        Me.OFD = New System.Windows.Forms.OpenFileDialog
        Me.GroupBox1.SuspendLayout()
        Me.GroupBox2.SuspendLayout()
        Me.SuspendLayout()
        '
        'GroupBox1
        '
        Me.GroupBox1.Controls.Add(Me.btnScanningOptions)
        Me.GroupBox1.Controls.Add(Me.cbxMaxBarHeight)
        Me.GroupBox1.Controls.Add(Me.cbxMinBarHeight)
        Me.GroupBox1.Controls.Add(Me.cbxQuietZone)
        Me.GroupBox1.Controls.Add(Me.chkIT25)
        Me.GroupBox1.Controls.Add(Me.chkUPCE)
        Me.GroupBox1.Controls.Add(Me.chkUPCA)
        Me.GroupBox1.Controls.Add(Me.chkEAN8)
        Me.GroupBox1.Controls.Add(Me.chkEAN13)
        Me.GroupBox1.Controls.Add(Me.chkEAN128)
        Me.GroupBox1.Controls.Add(Me.chkCode128)
        Me.GroupBox1.Controls.Add(Me.chkCode39)
        Me.GroupBox1.Controls.Add(Me.Label12)
        Me.GroupBox1.Controls.Add(Me.Label11)
        Me.GroupBox1.Controls.Add(Me.Label10)
        Me.GroupBox1.Controls.Add(Me.Label9)
        Me.GroupBox1.Controls.Add(Me.Label8)
        Me.GroupBox1.Controls.Add(Me.Label7)
        Me.GroupBox1.Controls.Add(Me.Label6)
        Me.GroupBox1.Controls.Add(Me.Label5)
        Me.GroupBox1.Controls.Add(Me.Label4)
        Me.GroupBox1.Controls.Add(Me.Label3)
        Me.GroupBox1.Controls.Add(Me.Label2)
        Me.GroupBox1.Controls.Add(Me.Label1)
        Me.GroupBox1.Controls.Add(Me.txtThreshold)
        Me.GroupBox1.Location = New System.Drawing.Point(16, 16)
        Me.GroupBox1.Name = "GroupBox1"
        Me.GroupBox1.Size = New System.Drawing.Size(216, 416)
        Me.GroupBox1.TabIndex = 0
        Me.GroupBox1.TabStop = False
        Me.GroupBox1.Text = "Scanning Options"
        '
        'btnScanningOptions
        '
        Me.btnScanningOptions.Location = New System.Drawing.Point(71, 360)
        Me.btnScanningOptions.Name = "btnScanningOptions"
        Me.btnScanningOptions.Size = New System.Drawing.Size(80, 32)
        Me.btnScanningOptions.TabIndex = 13
        Me.btnScanningOptions.Text = "Apply"
        '
        'cbxMaxBarHeight
        '
        Me.cbxMaxBarHeight.Items.AddRange(New Object() {"5", "6", "7", "8", "9"})
        Me.cbxMaxBarHeight.Location = New System.Drawing.Point(135, 306)
        Me.cbxMaxBarHeight.Name = "cbxMaxBarHeight"
        Me.cbxMaxBarHeight.Size = New System.Drawing.Size(64, 21)
        Me.cbxMaxBarHeight.TabIndex = 11
        '
        'cbxMinBarHeight
        '
        Me.cbxMinBarHeight.Items.AddRange(New Object() {"1", "2", "3", "4"})
        Me.cbxMinBarHeight.Location = New System.Drawing.Point(136, 279)
        Me.cbxMinBarHeight.Name = "cbxMinBarHeight"
        Me.cbxMinBarHeight.Size = New System.Drawing.Size(64, 21)
        Me.cbxMinBarHeight.TabIndex = 10
        '
        'cbxQuietZone
        '
        Me.cbxQuietZone.Items.AddRange(New Object() {"5", "10", "15", "20"})
        Me.cbxQuietZone.Location = New System.Drawing.Point(136, 255)
        Me.cbxQuietZone.Name = "cbxQuietZone"
        Me.cbxQuietZone.Size = New System.Drawing.Size(64, 21)
        Me.cbxQuietZone.TabIndex = 9
        '
        'chkIT25
        '
        Me.chkIT25.Checked = True
        Me.chkIT25.CheckState = System.Windows.Forms.CheckState.Checked
        Me.chkIT25.Location = New System.Drawing.Point(136, 204)
        Me.chkIT25.Name = "chkIT25"
        Me.chkIT25.Size = New System.Drawing.Size(16, 22)
        Me.chkIT25.TabIndex = 7
        '
        'chkUPCE
        '
        Me.chkUPCE.Checked = True
        Me.chkUPCE.CheckState = System.Windows.Forms.CheckState.Checked
        Me.chkUPCE.Location = New System.Drawing.Point(136, 177)
        Me.chkUPCE.Name = "chkUPCE"
        Me.chkUPCE.Size = New System.Drawing.Size(16, 22)
        Me.chkUPCE.TabIndex = 6
        '
        'chkUPCA
        '
        Me.chkUPCA.Checked = True
        Me.chkUPCA.CheckState = System.Windows.Forms.CheckState.Checked
        Me.chkUPCA.Location = New System.Drawing.Point(136, 150)
        Me.chkUPCA.Name = "chkUPCA"
        Me.chkUPCA.Size = New System.Drawing.Size(16, 22)
        Me.chkUPCA.TabIndex = 5
        '
        'chkEAN8
        '
        Me.chkEAN8.Checked = True
        Me.chkEAN8.CheckState = System.Windows.Forms.CheckState.Checked
        Me.chkEAN8.Location = New System.Drawing.Point(136, 126)
        Me.chkEAN8.Name = "chkEAN8"
        Me.chkEAN8.Size = New System.Drawing.Size(16, 22)
        Me.chkEAN8.TabIndex = 4
        '
        'chkEAN13
        '
        Me.chkEAN13.Checked = True
        Me.chkEAN13.CheckState = System.Windows.Forms.CheckState.Checked
        Me.chkEAN13.Location = New System.Drawing.Point(136, 99)
        Me.chkEAN13.Name = "chkEAN13"
        Me.chkEAN13.Size = New System.Drawing.Size(16, 22)
        Me.chkEAN13.TabIndex = 3
        '
        'chkEAN128
        '
        Me.chkEAN128.Checked = True
        Me.chkEAN128.CheckState = System.Windows.Forms.CheckState.Checked
        Me.chkEAN128.Location = New System.Drawing.Point(136, 72)
        Me.chkEAN128.Name = "chkEAN128"
        Me.chkEAN128.Size = New System.Drawing.Size(16, 22)
        Me.chkEAN128.TabIndex = 2
        '
        'chkCode128
        '
        Me.chkCode128.Checked = True
        Me.chkCode128.CheckState = System.Windows.Forms.CheckState.Checked
        Me.chkCode128.Location = New System.Drawing.Point(136, 48)
        Me.chkCode128.Name = "chkCode128"
        Me.chkCode128.Size = New System.Drawing.Size(16, 22)
        Me.chkCode128.TabIndex = 1
        '
        'chkCode39
        '
        Me.chkCode39.Checked = True
        Me.chkCode39.CheckState = System.Windows.Forms.CheckState.Checked
        Me.chkCode39.Location = New System.Drawing.Point(136, 21)
        Me.chkCode39.Name = "chkCode39"
        Me.chkCode39.Size = New System.Drawing.Size(16, 22)
        Me.chkCode39.TabIndex = 0
        '
        'Label12
        '
        Me.Label12.Location = New System.Drawing.Point(10, 310)
        Me.Label12.Name = "Label12"
        Me.Label12.Size = New System.Drawing.Size(120, 16)
        Me.Label12.TabIndex = 11
        Me.Label12.Text = "Max Bar Height in CMs"
        '
        'Label11
        '
        Me.Label11.Location = New System.Drawing.Point(10, 284)
        Me.Label11.Name = "Label11"
        Me.Label11.Size = New System.Drawing.Size(120, 16)
        Me.Label11.TabIndex = 10
        Me.Label11.Text = "Min Bar Height in CMs"
        '
        'Label10
        '
        Me.Label10.Location = New System.Drawing.Point(10, 258)
        Me.Label10.Name = "Label10"
        Me.Label10.Size = New System.Drawing.Size(120, 16)
        Me.Label10.TabIndex = 9
        Me.Label10.Text = "Quiet Zone"
        '
        'Label9
        '
        Me.Label9.Location = New System.Drawing.Point(10, 232)
        Me.Label9.Name = "Label9"
        Me.Label9.Size = New System.Drawing.Size(120, 16)
        Me.Label9.TabIndex = 8
        Me.Label9.Text = "Threshold"
        '
        'Label8
        '
        Me.Label8.Location = New System.Drawing.Point(10, 206)
        Me.Label8.Name = "Label8"
        Me.Label8.Size = New System.Drawing.Size(112, 16)
        Me.Label8.TabIndex = 7
        Me.Label8.Text = "Check Interleaved 25"
        '
        'Label7
        '
        Me.Label7.Location = New System.Drawing.Point(10, 180)
        Me.Label7.Name = "Label7"
        Me.Label7.Size = New System.Drawing.Size(112, 16)
        Me.Label7.TabIndex = 6
        Me.Label7.Text = "Check UPCE"
        '
        'Label6
        '
        Me.Label6.Location = New System.Drawing.Point(10, 154)
        Me.Label6.Name = "Label6"
        Me.Label6.Size = New System.Drawing.Size(112, 16)
        Me.Label6.TabIndex = 5
        Me.Label6.Text = "Check UPCA"
        '
        'Label5
        '
        Me.Label5.Location = New System.Drawing.Point(10, 128)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(112, 16)
        Me.Label5.TabIndex = 4
        Me.Label5.Text = "Check EAN8"
        '
        'Label4
        '
        Me.Label4.Location = New System.Drawing.Point(10, 102)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(112, 16)
        Me.Label4.TabIndex = 3
        Me.Label4.Text = "Check EAN13"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(10, 76)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(112, 16)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Check EAN128"
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(10, 50)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(112, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Check Code128"
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(10, 24)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(112, 16)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Check Code39"
        '
        'txtThreshold
        '
        Me.txtThreshold.Location = New System.Drawing.Point(136, 231)
        Me.txtThreshold.Name = "txtThreshold"
        Me.txtThreshold.Size = New System.Drawing.Size(56, 20)
        Me.txtThreshold.TabIndex = 8
        Me.txtThreshold.Text = "128"
        '
        'GroupBox2
        '
        Me.GroupBox2.Controls.Add(Me.btnImageInfo)
        Me.GroupBox2.Controls.Add(Me.txtRHeight)
        Me.GroupBox2.Controls.Add(Me.txtRWidth)
        Me.GroupBox2.Controls.Add(Me.txtRTop)
        Me.GroupBox2.Controls.Add(Me.txtRLeft)
        Me.GroupBox2.Controls.Add(Me.cbxPages)
        Me.GroupBox2.Controls.Add(Me.txtPages)
        Me.GroupBox2.Controls.Add(Me.txtHeight)
        Me.GroupBox2.Controls.Add(Me.txtWidth)
        Me.GroupBox2.Controls.Add(Me.Label21)
        Me.GroupBox2.Controls.Add(Me.Label20)
        Me.GroupBox2.Controls.Add(Me.Label19)
        Me.GroupBox2.Controls.Add(Me.Label18)
        Me.GroupBox2.Controls.Add(Me.Label17)
        Me.GroupBox2.Controls.Add(Me.Label16)
        Me.GroupBox2.Controls.Add(Me.Label15)
        Me.GroupBox2.Controls.Add(Me.Label14)
        Me.GroupBox2.Location = New System.Drawing.Point(246, 15)
        Me.GroupBox2.Name = "GroupBox2"
        Me.GroupBox2.Size = New System.Drawing.Size(174, 297)
        Me.GroupBox2.TabIndex = 1
        Me.GroupBox2.TabStop = False
        Me.GroupBox2.Text = "Image Info"
        '
        'btnImageInfo
        '
        Me.btnImageInfo.Enabled = False
        Me.btnImageInfo.Location = New System.Drawing.Point(49, 256)
        Me.btnImageInfo.Name = "btnImageInfo"
        Me.btnImageInfo.Size = New System.Drawing.Size(80, 32)
        Me.btnImageInfo.TabIndex = 4
        Me.btnImageInfo.Text = "Apply"
        '
        'txtRHeight
        '
        Me.txtRHeight.Location = New System.Drawing.Point(96, 223)
        Me.txtRHeight.Name = "txtRHeight"
        Me.txtRHeight.Size = New System.Drawing.Size(64, 20)
        Me.txtRHeight.TabIndex = 3
        Me.txtRHeight.Text = ""
        '
        'txtRWidth
        '
        Me.txtRWidth.Location = New System.Drawing.Point(96, 195)
        Me.txtRWidth.Name = "txtRWidth"
        Me.txtRWidth.Size = New System.Drawing.Size(64, 20)
        Me.txtRWidth.TabIndex = 2
        Me.txtRWidth.Text = ""
        '
        'txtRTop
        '
        Me.txtRTop.Location = New System.Drawing.Point(96, 167)
        Me.txtRTop.Name = "txtRTop"
        Me.txtRTop.Size = New System.Drawing.Size(64, 20)
        Me.txtRTop.TabIndex = 1
        Me.txtRTop.Text = ""
        '
        'txtRLeft
        '
        Me.txtRLeft.Location = New System.Drawing.Point(96, 139)
        Me.txtRLeft.Name = "txtRLeft"
        Me.txtRLeft.Size = New System.Drawing.Size(64, 20)
        Me.txtRLeft.TabIndex = 0
        Me.txtRLeft.Text = ""
        '
        'cbxPages
        '
        Me.cbxPages.Location = New System.Drawing.Point(96, 110)
        Me.cbxPages.Name = "cbxPages"
        Me.cbxPages.Size = New System.Drawing.Size(64, 21)
        Me.cbxPages.TabIndex = 15
        '
        'txtPages
        '
        Me.txtPages.Enabled = False
        Me.txtPages.Location = New System.Drawing.Point(96, 81)
        Me.txtPages.Name = "txtPages"
        Me.txtPages.Size = New System.Drawing.Size(64, 20)
        Me.txtPages.TabIndex = 10
        Me.txtPages.Text = ""
        '
        'txtHeight
        '
        Me.txtHeight.Enabled = False
        Me.txtHeight.Location = New System.Drawing.Point(96, 53)
        Me.txtHeight.Name = "txtHeight"
        Me.txtHeight.Size = New System.Drawing.Size(64, 20)
        Me.txtHeight.TabIndex = 9
        Me.txtHeight.Text = ""
        '
        'txtWidth
        '
        Me.txtWidth.Enabled = False
        Me.txtWidth.Location = New System.Drawing.Point(96, 25)
        Me.txtWidth.Name = "txtWidth"
        Me.txtWidth.Size = New System.Drawing.Size(64, 20)
        Me.txtWidth.TabIndex = 8
        Me.txtWidth.Text = ""
        '
        'Label21
        '
        Me.Label21.Location = New System.Drawing.Point(8, 227)
        Me.Label21.Name = "Label21"
        Me.Label21.Size = New System.Drawing.Size(78, 18)
        Me.Label21.TabIndex = 7
        Me.Label21.Text = "Region Height"
        '
        'Label20
        '
        Me.Label20.Location = New System.Drawing.Point(8, 198)
        Me.Label20.Name = "Label20"
        Me.Label20.Size = New System.Drawing.Size(78, 18)
        Me.Label20.TabIndex = 6
        Me.Label20.Text = "Region Width"
        '
        'Label19
        '
        Me.Label19.Location = New System.Drawing.Point(8, 169)
        Me.Label19.Name = "Label19"
        Me.Label19.Size = New System.Drawing.Size(69, 18)
        Me.Label19.TabIndex = 5
        Me.Label19.Text = "Region Top"
        '
        'Label18
        '
        Me.Label18.Location = New System.Drawing.Point(8, 140)
        Me.Label18.Name = "Label18"
        Me.Label18.Size = New System.Drawing.Size(69, 18)
        Me.Label18.TabIndex = 4
        Me.Label18.Text = "Region Left"
        '
        'Label17
        '
        Me.Label17.Location = New System.Drawing.Point(8, 111)
        Me.Label17.Name = "Label17"
        Me.Label17.Size = New System.Drawing.Size(87, 18)
        Me.Label17.TabIndex = 3
        Me.Label17.Text = "Choose A Page"
        '
        'Label16
        '
        Me.Label16.Location = New System.Drawing.Point(8, 82)
        Me.Label16.Name = "Label16"
        Me.Label16.Size = New System.Drawing.Size(48, 18)
        Me.Label16.TabIndex = 2
        Me.Label16.Text = "Pages"
        '
        'Label15
        '
        Me.Label15.Location = New System.Drawing.Point(8, 53)
        Me.Label15.Name = "Label15"
        Me.Label15.Size = New System.Drawing.Size(48, 18)
        Me.Label15.TabIndex = 1
        Me.Label15.Text = "Height"
        '
        'Label14
        '
        Me.Label14.Location = New System.Drawing.Point(8, 24)
        Me.Label14.Name = "Label14"
        Me.Label14.Size = New System.Drawing.Size(48, 18)
        Me.Label14.TabIndex = 0
        Me.Label14.Text = "Width"
        '
        'txtBarcodeInfo
        '
        Me.txtBarcodeInfo.Location = New System.Drawing.Point(441, 21)
        Me.txtBarcodeInfo.Multiline = True
        Me.txtBarcodeInfo.Name = "txtBarcodeInfo"
        Me.txtBarcodeInfo.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtBarcodeInfo.Size = New System.Drawing.Size(171, 408)
        Me.txtBarcodeInfo.TabIndex = 2
        Me.txtBarcodeInfo.Text = ""
        '
        'btnOpen
        '
        Me.btnOpen.Location = New System.Drawing.Point(271, 321)
        Me.btnOpen.Name = "btnOpen"
        Me.btnOpen.Size = New System.Drawing.Size(128, 24)
        Me.btnOpen.TabIndex = 0
        Me.btnOpen.Text = "Open An Image File"
        '
        'btnScan
        '
        Me.btnScan.Location = New System.Drawing.Point(271, 361)
        Me.btnScan.Name = "btnScan"
        Me.btnScan.Size = New System.Drawing.Size(128, 24)
        Me.btnScan.TabIndex = 1
        Me.btnScan.Text = "Scan It"
        '
        'btnClose
        '
        Me.btnClose.Location = New System.Drawing.Point(271, 401)
        Me.btnClose.Name = "btnClose"
        Me.btnClose.Size = New System.Drawing.Size(128, 24)
        Me.btnClose.TabIndex = 2
        Me.btnClose.Text = "Close"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(632, 446)
        Me.Controls.Add(Me.btnClose)
        Me.Controls.Add(Me.btnScan)
        Me.Controls.Add(Me.btnOpen)
        Me.Controls.Add(Me.txtBarcodeInfo)
        Me.Controls.Add(Me.GroupBox2)
        Me.Controls.Add(Me.GroupBox1)
        Me.Name = "Form1"
        Me.Text = "Demo"
        Me.GroupBox1.ResumeLayout(False)
        Me.GroupBox2.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

    Private Sub Init_GUI()
        cbxQuietZone.SelectedIndex = 1
        cbxMinBarHeight.SelectedIndex = 1
        cbxMaxBarHeight.SelectedIndex = 1
    End Sub

#End Region

#Region "Private Functions"
    Private Function GetImgFormat(ByVal ImgName As String)
        Dim pos As Integer
        Dim ext_name As String
        Dim result As Integer

        pos = InStr(ImgName, ".")
        ext_name = Mid(ImgName, pos + 1)

        If (StrComp(ext_name, "bmp", vbTextCompare) = 0) Then
            result = 1
        ElseIf (StrComp(ext_name, "gif", vbTextCompare) = 0) Then
            result = 2
        ElseIf (StrComp(ext_name, "ico", vbTextCompare) = 0) Then
            result = 3
        ElseIf ((StrComp(ext_name, "jpg", vbTextCompare) = 0) Or _
                (StrComp(ext_name, "jpeg", vbTextCompare) = 0)) Then
            result = 4
        ElseIf (StrComp(ext_name, "png", vbTextCompare) = 0) Then
            result = 5
        ElseIf ((StrComp(ext_name, "tif", vbTextCompare) = 0) Or _
                (StrComp(ext_name, "tiff", vbTextCompare) = 0)) Then
            result = 6
        ElseIf (StrComp(ext_name, "wmf", vbTextCompare) = 0) Then
            result = 7
        Else
            result = -1
        End If

        GetImgFormat = result
    End Function

    Private Sub btnScanningOptions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnScanningOptions.Click
        On Error GoTo ErrorHandler

        If (chkCode39.Checked) Then
            ' enable scanning code39
            bCode39 = True
        Else
            ' disable scanning code39
            bCode39 = False
        End If

        If (chkCode128.Checked) Then
            ' enable scanning code128
            bCode128 = True
        Else
            ' disable scanning code128
            bCode128 = False
        End If

        If (chkEAN128.Checked) Then
            ' enable scanning EAN128
            bEAN128 = True
        Else
            ' disable scanning EAN128
            bEAN128 = False
        End If

        If (chkEAN13.Checked) Then
            ' enable scanning EAN13
            bEAN13 = True
        Else
            ' disable scanning EAN13
            bEAN13 = False
        End If

        If (chkEAN8.Checked) Then
            ' enable scanning EAN8
            bEAN8 = True
        Else
            ' disable scanning EAN8
            bEAN8 = False
        End If

        If (chkUPCA.Checked) Then
            ' enable scanning UPCA
            bUPCA = True
        Else
            ' disable scanning UPCA
            bUPCA = False
        End If

        If (chkUPCE.Checked) Then
            ' enable scanning UPCE
            bUPCE = True
        Else
            ' disable scanning UPCE
            bUPCE = False
        End If

        If (chkIT25.Checked) Then
            ' enable scanning Interleaved 25
            bIT25 = True
        Else
            ' disable scanning Interleaved 25
            bIT25 = False
        End If

        nThreshold = CInt(txtThreshold.Text)
        dQuietZone = CDbl(cbxQuietZone.Text)
        dMinBarHeight = CDbl(cbxMinBarHeight.Text)
        dMaxBarHeight = CDbl(cbxMaxBarHeight.Text)

        Exit Sub

ErrorHandler:
    End Sub

    Private Sub btnImageInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnImageInfo.Click
        Dim tmp As String
        Dim ErrorMsg As String

        On Error GoTo ErrorHandler

        ' Region's left value
        nRLeft = CInt(txtRLeft.Text)
        If ((nRLeft < 0) Or (nRLeft >= nImgWidth)) Then
            ErrorMsg = ErrorMsg & "Left value must be between 0 and image width minus 1." & vbCrLf
            nRLeft = 0
        End If

        ' Region's top value
        nRTop = CInt(txtRTop.Text)
        If ((nRTop < 0) Or (nRTop >= nImgHeight)) Then
            ErrorMsg = ErrorMsg & "Left value must be between 0 and image height minus 1." & vbCrLf
            nRTop = 0
        End If

        ' Region's right value
        nRRight = nRLeft + CInt(txtRWidth.Text) - 1
        If ((nRRight < nRLeft) Or (nRRight >= nImgWidth)) Then
            ErrorMsg = ErrorMsg & "Right value must be between left value and image width minus 1." & vbCrLf
            nRRight = nImgWidth - 1
        End If

        ' Region's bottom value
        nRBottom = nRTop + CInt(txtRHeight.Text) - 1
        If ((nRBottom < nRTop) Or (nRBottom >= nImgHeight)) Then
            ErrorMsg = ErrorMsg & "Bottom value must be between top value and image height minus 1." & vbCrLf
            nRBottom = nImgHeight - 1
        End If

        If (Len(ErrorMsg) > 0) Then
            MsgBox(ErrorMsg)
        End If

        Exit Sub

ErrorHandler:
    End Sub

    Private Sub cbxPages_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxPages.SelectedIndexChanged
        Dim result As Integer
        Dim w As Integer
        Dim h As Integer

        If ((nImgFormat = 2) Or (nImgFormat = 6)) Then
            ' Page option for TIF or GIF
            nPageOption = CInt(cbxPages.Text)

            result = De1DSetPage(nPageOption)

            If (result = 1) Then
                result = De1DGetImgSize(w, h)

                txtWidth.Text = System.Convert.ToString(w)
                txtRWidth.Text = System.Convert.ToString(w)

                txtHeight.Text = System.Convert.ToString(h)
                txtRHeight.Text = System.Convert.ToString(h)

                txtRLeft.Text = "0"
                txtRTop.Text = "0"

                nRLeft = 0
                nRTop = 0
                nRRight = w - 1
                nRBottom = h - 1
                nImgWidth = w
                nImgHeight = h
            End If
        End If
    End Sub

#End Region

    Private Sub btnOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpen.Click
        Dim file_name As String
        Dim file_size As Long
        Dim pos As Long
        Dim read_count As Integer
        Dim buffer() As Byte
        Dim ByteBuffer() As Byte
        Dim result As Integer
        Dim P As Integer
        Dim I As Integer
        Dim w As Integer
        Dim h As Integer

        ' clean file name
        OFD.FileName = ""

        OFD.ShowDialog()

        file_name = OFD.FileName

        If (Len(file_name) = 0) Then
            Exit Sub
        End If

        ' get image format info
        nImgFormat = GetImgFormat(file_name)

        If (nImgFormat = -1) Then
            ' invalid image format
            Exit Sub
        End If

        ' load image content into the library directly from the file on the disk
        result = De1DLoadFromFile(file_name, nImgFormat)

        If (result = 1) Then
            ' loading is OK
            If ((nImgFormat = 2) Or (nImgFormat = 6)) Then
                ' TIF or GIF file

                ' how many pages
                P = De1DGetNumOfPages()
                txtPages.Text = System.Convert.ToString(P)
                cbxPages.Items.Clear()

                ' update page list
                For I = 0 To (P - 1)
                    cbxPages.Items.Add(I)
                Next I

                cbxPages.SelectedIndex = 0

                ' choose 1st page
                result = De1DSetPage(0)

                If (result = 1) Then
                    ' image size
                    result = De1DGetImgSize(w, h)

                    txtWidth.Text = System.Convert.ToString(w)
                    txtRWidth.Text = System.Convert.ToString(w)

                    txtHeight.Text = System.Convert.ToString(h)
                    txtRHeight.Text = System.Convert.ToString(h)

                    txtRLeft.Text = "0"
                    txtRTop.Text = "0"

                    nRLeft = 0
                    nRTop = 0
                    nRRight = w - 1
                    nRBottom = h - 1
                    nImgWidth = w
                    nImgHeight = h
                End If
            Else
                txtPages.Text = ""
                cbxPages.Items.Clear()

                ' Other image formats
                txtPages.Text = ""
                cbxPages.Items.Clear()

                ' image size
                result = De1DGetImgSize(w, h)

                txtWidth.Text = System.Convert.ToString(w)
                txtRWidth.Text = System.Convert.ToString(w)

                txtHeight.Text = System.Convert.ToString(h)
                txtRHeight.Text = System.Convert.ToString(h)

                txtRLeft.Text = "0"
                txtRTop.Text = "0"

                nRLeft = 0
                nRTop = 0
                nRRight = w - 1
                nRBottom = h - 1
                nImgWidth = w
                nImgHeight = h
            End If
            btnImageInfo.Enabled = True
        Else
            btnImageInfo.Enabled = False
        End If
    End Sub

    Private Sub btnScan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnScan.Click
        Dim result As Integer
        Dim count As Integer
        Dim info As String
        Dim BarcodeType As Integer
        Dim I As Integer
        Dim J As Integer
        Dim X As Int32
        Dim Y As Int32
        Dim StrLen As Integer
        Dim Point(3) As Long
        Dim OneChar As Integer
        Dim BarcodeInfo As String

        ' enable/disable scanning Code39
        If (bCode39) Then
            result = De1DScanType(0, 1)
        Else
            result = De1DScanType(0, 0)
        End If

        ' enable/disable scanning Code128
        If (bCode128) Then
            result = De1DScanType(1, 1)
        Else
            result = De1DScanType(1, 0)
        End If

        ' enable/disable scanning EAN128
        If (bEAN128) Then
            result = De1DScanType(2, 1)
        Else
            result = De1DScanType(2, 0)
        End If

        ' enable/disable scanning EAN13
        If (bEAN13) Then
            result = De1DScanType(3, 1)
        Else
            result = De1DScanType(3, 0)
        End If

        ' enable/disable scanning EAN8
        If (bEAN8) Then
            result = De1DScanType(4, 1)
        Else
            result = De1DScanType(4, 0)
        End If

        ' enable/disable scanning UPCA
        If (bUPCA) Then
            result = De1DScanType(5, 1)
        Else
            result = De1DScanType(5, 0)
        End If

        ' enable/disable scanning UPCE
        If (bUPCE) Then
            result = De1DScanType(6, 1)
        Else
            result = De1DScanType(6, 0)
        End If

        ' enable/disable scanning Interleaved 25
        If (bIT25) Then
            result = De1DScanType(7, 1)
        Else
            result = De1DScanType(7, 0)
        End If

        ' For full version library, pass the 10-digit license key to this function
        ' Sample code:
        ' result = De1DSetKey("123456-7890");
        result = De1DSetKey("DEMO")

        result = De1DSetThreshold(nThreshold)

        result = De1DSetLimit(dQuietZone, dMinBarHeight, dMaxBarHeight)

        result = De1DSetRegion(nRLeft, nRTop, nRRight, nRBottom)

        result = De1DScan()

        count = De1DGetCount()

        If (count > 0) Then
            If (count = 1) Then
                BarcodeInfo = "1 Barcode Found" & vbCrLf
            Else
                BarcodeInfo = count & " Barcodes Found" & vbCrLf
            End If

            For I = 1 To count
                BarcodeInfo = BarcodeInfo & "[Barcode " & System.Convert.ToString(I) + "]" & vbCrLf

                ' barcode type
                BarcodeType = De1DGetType(I - 1)
                If (BarcodeType = 0) Then
                    BarcodeInfo = BarcodeInfo + "Type: Code39" & vbCrLf
                ElseIf (BarcodeType = 1) Then
                    BarcodeInfo = BarcodeInfo + "Type: Code128" & vbCrLf
                ElseIf (BarcodeType = 2) Then
                    BarcodeInfo = BarcodeInfo + "Type: EAN128" & vbCrLf
                ElseIf (BarcodeType = 3) Then
                    BarcodeInfo = BarcodeInfo + "Type: EAN13" & vbCrLf
                ElseIf (BarcodeType = 4) Then
                    BarcodeInfo = BarcodeInfo + "Type: EAN8" & vbCrLf
                ElseIf (BarcodeType = 5) Then
                    BarcodeInfo = BarcodeInfo + "Type: UPCA" & vbCrLf
                ElseIf (BarcodeType = 6) Then
                    BarcodeInfo = BarcodeInfo + "Type: UPCE" & vbCrLf
                ElseIf (BarcodeType = 7) Then
                    BarcodeInfo = BarcodeInfo + "Type: Interleaved 25" & vbCrLf
                End If

                ' barcode boundary rectangle
                Call De1DGetRect(I - 1, Point(0), Point(1), Point(2), Point(3))
                For J = 1 To 4
                    X = Point(J - 1) / &H10000
                    Y = Point(J - 1) And &HFFFF
                    BarcodeInfo = BarcodeInfo & "Point " & J & ": (" & X & ", " & Y & ")" & vbCrLf
                Next J

                ' the string encoded by this barcode
                StrLen = De1DGetStrLen(I - 1)
                BarcodeInfo = BarcodeInfo & "String length: " & StrLen & vbCrLf
                BarcodeInfo = BarcodeInfo & "String: "
                For J = 0 To (StrLen - 1)
                    OneChar = System.Convert.ToByte(De1DGetCharAt(I - 1, J) And &HFF)
                    OneChar = OneChar And &HFF
                    If ((BarcodeType = 1 Or BarcodeType = 2) And _
                        ((OneChar >= 201) And (OneChar <= 204))) Then
                        ' code128 or EAN128
                        ' FNC 1, FNC 2, FNC 3 or FNC 4
                        BarcodeInfo = BarcodeInfo & "FNC " & (OneChar - 200)
                    Else
                        BarcodeInfo = BarcodeInfo & Chr(OneChar)
                    End If
                Next J

                BarcodeInfo = BarcodeInfo & vbCrLf & vbCrLf
            Next I
            txtBarcodeInfo.Text = BarcodeInfo
        Else
            txtBarcodeInfo.Text = "No barcode found."
        End If

    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        ' free up memory
        De1DCleanUp()

        Me.Close()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Call De1DInit()

        chkCode39.Checked = True
        chkCode128.Checked = True
        chkEAN128.Checked = True
        chkEAN13.Checked = True
        chkEAN8.Checked = True
        chkUPCA.Checked = True
        chkUPCE.Checked = True
        chkIT25.Checked = True

        txtThreshold.Text = 128
        cbxQuietZone.SelectedIndex = 1
        cbxMinBarHeight.SelectedIndex = 0
        cbxMaxBarHeight.SelectedIndex = 0
        txtBarcodeInfo.Text = ""

        bCode39 = True
        bCode128 = True
        bEAN128 = True
        bEAN13 = True
        bEAN8 = True
        bUPCA = True
        bUPCE = True
        bIT25 = True
        nThreshold = 128
        dQuietZone = 10
        dMinBarHeight = 1
        dMaxBarHeight = 5
        bDiskFile = True
    End Sub
End Class
